(* Time-stamp: <modified the 16/02/2024 (at 15:02) by Erwan Jahier> *)


(* generate an header for languages that do not have one-line comments *)
let entete2 comment_open comment_close version sha =
  let time = Unix.localtime (Unix.time ()) in
  let date = (
	(string_of_int time.Unix.tm_mday) ^ "/" ^
	  (string_of_int (time.Unix.tm_mon+1)) ^  "/" ^
	  (string_of_int (1900+time.Unix.tm_year))
      )
  and time_str = (
    (string_of_int time.Unix.tm_hour) ^  ":" ^
      (if time.Unix.tm_min < 10 then "0" else "") ^
      (string_of_int time.Unix.tm_min) ^   ":" ^
      (if time.Unix.tm_sec < 10 then "0" else "") ^
      (string_of_int time.Unix.tm_sec)
  )
  and hostname = Unix.gethostname ()
  in
    (comment_open ^ " Automatically generated by "^
     Sys.executable_name^" version \""^version^"\" (\"" ^sha^"\")"^
     comment_close^"\n" ^  comment_open ^ " on " ^ hostname ^
       " the " ^ date ^ " at " ^ time_str ^comment_close^"\n" ^
     comment_open^(String.concat " " (Array.to_list Sys.argv))^
     comment_close^"\n\n")

(* for one-line comments *)
let entete comment version sha = entete2 comment "" version sha


(*  *)
let (gen_file : open_flag -> string -> string -> string -> unit) =
  fun flag name label str ->
  let oc = open_out_gen [Open_wronly; Open_creat; flag] 0o766 name in
  Printf.fprintf oc "%s\n%!" str;
  close_out oc;
  Printf.printf "[%s] %s has been %s\n%!" label name
    (if flag = Open_append && Sys.file_exists name then "updated" else "generated")


(* returns the cartesian product of 2 lists *)
let (list_product : 'a list -> 'b list -> ('a * 'b) list list) =
  fun l1 l2 ->
  List.map (fun b -> List.map (fun a -> (a,b)) l1) l2


let _ = assert (
  list_product ["f1";"f2";"f3"] ["arg1";"arg2";"arg3";"arg4"] =
  [["f1","arg1" ; "f2","arg1" ; "f3","arg1"];
   ["f1","arg2" ; "f2","arg2" ; "f3","arg2"];
   ["f1","arg3" ; "f2","arg3" ; "f3","arg3"];
   ["f1","arg4" ; "f2","arg4" ; "f3","arg4"]]
)
